=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-03-06 02:35:59 +0000
+++ loggerhead/history.py	2008-03-10 04:17:25 +0000
@@ -308,17 +308,26 @@
     def get_revision_history(self):
         return self._full_history
 
-    def get_revids_from(self, revid_list, revid):
-        """
-        given a list of revision ids, yield revisions in graph order,
-        starting from revid.  the list can be None if you just want to travel
-        across all revisions.
-        """
-        while True:
-            if (revid_list is None) or (revid in revid_list):
+    def get_revids_from(self, revid_list, start_revid):
+        """
+        Yield the mainline (wrt start_revid) revisions that merged each
+        revid in revid_list.
+        """
+        if revid_list is None:
+            revid_list = self._full_history
+        revid_set = set(revid_list)
+        revid = start_revid
+        def introduced_revisions(revid):
+            r = set([revid])
+            seq, revid, md, revno, end_of_merge = self._revision_info[revid]
+            i = seq + 1
+            while i < len(self._merge_sort) and self._merge_sort[i][2] > md:
+                r.add(self._merge_sort[i][1])
+                i += 1
+            return r
+        while 1:
+            if introduced_revisions(revid) & revid_set:
                 yield revid
-            if not self._revision_graph.has_key(revid):
-                return
             parents = self._revision_graph[revid]
             if len(parents) == 0:
                 return

